import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsDictionarycategory {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  Name?: string;
  Code?: string;
  Description?: string;
  Enabled!: unknown;
  Sort!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsDictionarycategorySchema = defineEntity({
  class: ScsDictionarycategory,
  comment: '数据字典分类',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    Name: p.string().name('Name').length(20).nullable().comment('名称'),
    Code: p.string().name('Code').length(20).nullable().comment('编码'),
    Description: p.string().name('Description').length(100).nullable().comment('描述'),
    Enabled: p.array().name('Enabled').comment('启用'),
    Sort: p.integer().name('Sort').comment('排序'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
